import cloneDeep from 'clone-deep';
import cssToRN from 'css-to-react-native';
import * as React from 'react';
import * as RN from 'react-native';

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

var _excluded = ["style"];
var __reactCreateElement__ = React.createElement;
var emptyObj = {};
function createStyles(options) {
  var _options$themes, _options$tokens;

  if (options === void 0) {
    options = emptyObj;
  }

  var themes = (_options$themes = options.themes) !== null && _options$themes !== void 0 ? _options$themes : emptyObj;
  var currentTheme = "default";
  var tokens = {
    default: (_options$tokens = options.tokens) !== null && _options$tokens !== void 0 ? _options$tokens : emptyObj
  };

  if (options.themes) {
    var themeNames = Object.keys(options.themes);
    currentTheme = themeNames[0];

    for (var themeName of themeNames) {
      tokens[themeName] = mergeTokens(cloneDeep(tokens.default), themes[themeName]);
    }

    var colorScheme = RN.Appearance.getColorScheme();

    if (themeNames.length === 2 && "light" in tokens && "dark" in tokens && colorScheme && colorScheme in themes) {
      currentTheme = colorScheme;
    }
  }

  function cls(literals) {
    for (var _len = arguments.length, placeholders = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      placeholders[_key - 1] = arguments[_key];
    }

    var styles = compileStyles(compileLiterals(literals, ...placeholders), tokens[currentTheme]);

    return styles;
  }

  var styles = Object.assign(function styles(styleMap) {
    // style('text', {})
    function style() {
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      var numArgs = args.length;
      var sheet = styleMap.default ? compileStyles(styleMap.default, tokens[currentTheme]) : {};

      if (numArgs === 1 && typeof args[0] === "string") {
        Object.assign(sheet, compileStyles(styleMap[args[0]], tokens[currentTheme]));
      } else if (numArgs > 0) {
        var i = 0;
        var arg;

        for (; i < numArgs; i++) {
          arg = args[i];

          if (typeof arg === "string") {
            Object.assign(sheet, compileStyles(styleMap[arg], tokens[currentTheme]));
          } else if (typeof arg === "object") {
            for (var key in arg) {
              if (arg[key]) Object.assign(sheet, compileStyles(styleMap[key], tokens[currentTheme]));
            }
          }
        }
      }

      return sheet;
    }

    style.styles = styleMap;
    return style;
  }, {
    one(literals) {
      for (var _len3 = arguments.length, placeholders = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
        placeholders[_key3 - 1] = arguments[_key3];
      }

      var styles = compileStyles(compileLiterals(literals, ...placeholders), tokens[currentTheme]);

      return Object.assign(function oneStyle(createStyle) {
        if (!createStyle && createStyle !== void 0) return emptyObj;
        return styles;
      }, {
        styles
      });
    },

    cls,

    lazy(lazyFn) {
      return function (value) {
        if (!value) return emptyObj;
        var styles = compileStyles(lazyFn(value), tokens[currentTheme]);

        return styles;
      };
    },

    join() {
      return cls("".concat(...arguments));
    },

    tokens
  });
  var DashContext = /*#__PURE__*/React.createContext({
    styles,
    theme: currentTheme,

    setTheme(theme) {
      console.error("DashContext was consumed outside of a Provider");
    }

  });
  /**
   * A hook for consuming dash context from the provider
   */

  function useDash() {
    return React.useContext(DashContext);
  }

  var styled = function styled(Component, styles) {
    var RefForwardingComponent = /*#__PURE__*/React.forwardRef(function StyledComponent(_ref, ref) {
      var {
        style
      } = _ref,
          props = _objectWithoutPropertiesLoose(_ref, _excluded);

      var {
        theme
      } = useDash();
      var baseStyle = compileStyles(styles, tokens[theme]);
      var outerStyle = typeof style === "function" || typeof style === "string" ? compileStyles(style, tokens[theme]) : style;
      return /*#__PURE__*/__reactCreateElement__(Component, _extends({}, props, {
        style: outerStyle && baseStyle ? RN.StyleSheet.flatten([baseStyle, outerStyle]) : outerStyle ? outerStyle : baseStyle,
        ref: ref
      }));
    }); // if ("production" !== "production") {
    //   RefForwardingComponent.displayName = `styled(${
    //     Component.displayName ?? (Component.name || "Component")
    //   })`;
    // }

    return RefForwardingComponent;
  };

  function wrapStyled(Component) {
    return function styledWrapper(literals) {
      for (var _len4 = arguments.length, placeholders = new Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
        placeholders[_key4 - 1] = arguments[_key4];
      }

      return styled(Component, Array.isArray(literals) ? compileLiterals(literals, ...placeholders) : literals);
    };
  }

  styled.ActivityIndicator = wrapStyled(RN.ActivityIndicator);
  styled.DrawerLayoutAndroid = wrapStyled(RN.DrawerLayoutAndroid);
  styled.FlatList = wrapStyled(RN.FlatList);
  styled.Image = wrapStyled(RN.Image);
  styled.ImageBackground = wrapStyled(RN.ImageBackground);
  styled.KeyboardAvoidingView = wrapStyled(RN.KeyboardAvoidingView);
  styled.Modal = wrapStyled(RN.Modal);
  styled.NavigatorIOS = wrapStyled(RN.NavigatorIOS);
  styled.RecyclerViewBackedScrollView = wrapStyled(RN.RecyclerViewBackedScrollView);
  styled.RefreshControl = wrapStyled(RN.RefreshControl);
  styled.SafeAreaView = wrapStyled(RN.SafeAreaView);
  styled.ScrollView = wrapStyled(RN.ScrollView);
  styled.SectionList = wrapStyled(RN.SectionList);
  styled.SnapshotViewIOS = wrapStyled(RN.SnapshotViewIOS);
  styled.Switch = wrapStyled(RN.Switch);
  styled.Text = wrapStyled(RN.Text);
  styled.TextInput = wrapStyled(RN.TextInput);
  styled.TouchableHighlight = wrapStyled(RN.TouchableHighlight);
  styled.TouchableNativeFeedback = wrapStyled(RN.TouchableNativeFeedback);
  styled.TouchableOpacity = wrapStyled(RN.TouchableOpacity);
  styled.TouchableWithoutFeedback = wrapStyled(RN.TouchableWithoutFeedback);
  styled.View = wrapStyled(RN.View);
  return {
    styles,
    styled,
    useDash,

    DashProvider(_ref2) {
      var {
        defaultTheme,
        children
      } = _ref2;
      var colorScheme = RN.useColorScheme();
      var [theme, setTheme] = React.useState(() => {
        if (defaultTheme) {
          currentTheme = defaultTheme;
          return defaultTheme;
        }

        if (colorScheme && colorScheme in themes) {
          currentTheme = colorScheme;
          return colorScheme;
        }

        return currentTheme;
      });
      React.useLayoutEffect(() => {
        if (theme) currentTheme = theme;
      }, [theme]);
      React.useLayoutEffect(() => {
        if (colorScheme && colorScheme !== theme && // light + dark + default
        Object.values(themes).length === 3 && "light" in themes && "dark" in themes) {
          currentTheme = colorScheme;
        }
      }, [colorScheme, theme]);
      return /*#__PURE__*/__reactCreateElement__(DashContext.Provider, {
        value: React.useMemo(() => ({
          styles,
          theme,
          setTheme
        }), [theme]),
        children: children
      });
    }

  };
}
/**
 * A utility function that will compile style objects and callbacks into CSS strings.
 *
 * @param styles - A style callback, object, or string
 * @param tokens - A map of CSS tokens for style callbacks
 */

function compileStyles(styles, tokens) {
  var value = typeof styles === "function" ? styles(tokens) : styles;

  if (typeof value !== "string") {
    return value || {};
  }

  var cache = compileCache.get(tokens);

  if (!cache) {
    cache = new Map();
    compileCache.set(tokens, cache);
  }

  var cachedStyle = cache.get(value);
  if (cachedStyle) return cachedStyle;
  var stylePairs = [];
  var splitValue = value.split(";");

  for (var i = 0; i < splitValue.length; i++) {
    // Get prop name and prop value
    var match = propertyValuePattern.exec(splitValue[i]);
    if (match !== null) stylePairs.push([match[1], match[2]]);
  }

  try {
    var style = cssToRN(stylePairs);
    cache.set(value, style);
    return style;
  } catch (error) {
    var msg = error.message;

    if (msg.includes("Failed to parse declaration")) {
      var values = msg.replace("Failed to parse declaration ", "").replace(/"/g, "").trim().split(":");
      console.error("'" + values[0] + "' shorthand property requires units for example - " + values[0] + ": 20px or " + values[0] + ": 10px 20px 40px 50px");
    }

    var _style = {};
    cache.set(value, _style);
    return _style;
  }
}
var compileCache = /*#__PURE__*/new WeakMap();

function mergeTokens(target, source) {
  for (var key in source) {
    var _target$key;

    var _value = source[key];
    target[key] = typeof _value === "object" && _value !== null && !Array.isArray(_value) ? mergeTokens((_target$key = target[key]) !== null && _target$key !== void 0 ? _target$key : {}, _value) : _value;
  }

  return target;
}

var propertyValuePattern = /\s*([^\s]+)\s*:\s*(.+?)\s*$/;

function compileLiterals(literals) {
  for (var _len5 = arguments.length, replacements = new Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
    replacements[_key5 - 1] = arguments[_key5];
  }

  return Array.isArray(literals) ? literals.reduce((curr, next, i) => curr + next + (replacements[i] || ""), "") : literals;
}

export { compileStyles, createStyles };
//# sourceMappingURL=index.dev.mjs.map
